require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/tools/indicators', type: :request do
  # Tools::Indicator. As you add validations to Tools::Indicator, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { FactoryBot.attributes_for(:indicator, rca_id: rca.id) }
  let(:invalid_attributes) { FactoryBot.attributes_for(:indicator, name: nil, rca_id: rca.id) }

  let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }

  context 'From logged user' do
    before :each do
      user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      user.save!

      sign_in user
    end

    describe 'GET /index' do
      context 'without rca defined' do
        it 'renders a redirection response' do
          get '/tools/indicators'
          expect(response).to have_http_status(:redirect)
          expect(response).to redirect_to(rcas_path)
        end
      end

      context 'with rca and step_tool defined' do
        it 'renders a successful response' do
          Tools::Indicator.create! valid_attributes
          get tools_indicators_url(rca: rca.id)
          expect(response).to be_successful
        end
      end
    end

    # describe 'GET /show' do
    #   it 'renders a successful response' do
    #     tools_indicator = Tools::Indicator.create! valid_attributes
    #     get tools_indicator_url(tools_indicator)
    #     expect(response).to be_successful
    #   end
    # end

    describe 'GET /new' do
      context 'without rca defined' do
        it 'renders a redirection response' do
          get new_tools_task_path, params: {}, xhr: true
          expect(response).to have_http_status(:redirect)
          expect(response).to redirect_to(rcas_path)
        end
      end

      context 'with rca and attributes defined' do
        it 'renders a successful response' do
          get new_tools_indicator_url, params: { tools_indicator: valid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        tools_indicator = Tools::Indicator.create! valid_attributes
        get edit_tools_indicator_url(tools_indicator), params: {}, xhr: true
        expect(response).to be_successful
      end
    end

    describe 'POST /create' do
      context 'with valid parameters' do
        it 'creates a new Tools::Indicator' do
          expect {
            post tools_indicators_url, params: { tools_indicator: valid_attributes }
          }.to change(Tools::Indicator, :count).by(1)
        end

        it 'redirects to the tools_indicators page' do
          post tools_indicators_url, params: { tools_indicator: valid_attributes }
          expect(response).to redirect_to(tools_indicators_url(rca: rca.id))
        end
      end

      context 'with invalid parameters' do
        it 'does not create a new Tools::Indicator' do
          expect {
            post tools_indicators_url, params: { tools_indicator: invalid_attributes }, xhr: true
          }.to change(Tools::Indicator, :count).by(0)
        end

        it 'renders a successful response (i.e. to display the new template)' do
          post tools_indicators_url, params: { tools_indicator: invalid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { FactoryBot.attributes_for(:indicator, name: 'new name', rca: rca) }

        it 'updates the requested tools_indicator' do
          tools_indicator = Tools::Indicator.create! valid_attributes
          patch tools_indicator_url(tools_indicator), params: { tools_indicator: new_attributes }
          tools_indicator.reload

          expect(tools_indicator.name).to eq 'new name'
        end

        it 'redirects to the tools_indicator' do
          tools_indicator = Tools::Indicator.create! valid_attributes
          patch tools_indicator_url(tools_indicator), params: { tools_indicator: new_attributes }
          tools_indicator.reload
          expect(response).to redirect_to(tools_indicators_url(rca: rca.id))
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          tools_indicator = Tools::Indicator.create! valid_attributes
          patch tools_indicator_url(tools_indicator), params: { tools_indicator: invalid_attributes }, xhr: true
          expect(response).to be_successful
        end
      end
    end

    describe 'DELETE /destroy' do
      it 'destroys the requested tools_indicator' do
        tools_indicator = Tools::Indicator.create! valid_attributes
        expect {
          delete tools_indicator_url(tools_indicator)
        }.to change(Tools::Indicator, :count).by(-1)
      end

      it 'redirects to the tools_indicators list' do
        tools_indicator = Tools::Indicator.create! valid_attributes
        delete tools_indicator_url(tools_indicator)
        expect(response).to redirect_to(tools_indicators_url(rca: rca.id))
      end
    end
  end
end
